searchNodes=[{"ref":"ExRerun.html","title":"ExRerun","type":"module","doc":"Recompiles mix project on any change to the project src files."},{"ref":"ExRerun.html#start/2","title":"ExRerun.start/2","type":"function","doc":""},{"ref":"ExRerun.Worker.html","title":"ExRerun.Worker","type":"module","doc":"The main worker of the ExRerun project."},{"ref":"ExRerun.Worker.html#child_spec/1","title":"ExRerun.Worker.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"ExRerun.Worker.html#get_dir_mtimes/1","title":"ExRerun.Worker.get_dir_mtimes/1","type":"function","doc":"Returns a flatten list of file_mtime for all files in directory, dir."},{"ref":"ExRerun.Worker.html#init/1","title":"ExRerun.Worker.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"ExRerun.Worker.html#normalize_task_name/1","title":"ExRerun.Worker.normalize_task_name/1","type":"function","doc":""},{"ref":"ExRerun.Worker.html#rerun_tasks/0","title":"ExRerun.Worker.rerun_tasks/0","type":"function","doc":""},{"ref":"ExRerun.Worker.html#start_link/0","title":"ExRerun.Worker.start_link/0","type":"function","doc":""},{"ref":"ExRerun.Worker.html#t:file_mtime/0","title":"ExRerun.Worker.file_mtime/0","type":"type","doc":""},{"ref":"ExRerun.Worker.html#t:state/0","title":"ExRerun.Worker.state/0","type":"type","doc":""},{"ref":"getting-started.html","title":"Getting Started","type":"extras","doc":"Getting Started"},{"ref":"getting-started.html#project-setup","title":"Getting Started - Project Setup","type":"extras","doc":"To use ExRerun with your projects, edit your mix.exs file and add it as a dependency. defp deps do [{:ex_rerun, &quot;~&gt; 0.3&quot;, only: :dev}] end"},{"ref":"getting-started.html#what-is-exrerun","title":"Getting Started - What is ExRerun","type":"extras","doc":"ExRerun is a package that is monitors your Elixir, and other source files, while you are develop your application and then reruns a set of mix tasks whenever a source file is added, deleted, or changed."},{"ref":"getting-started.html#configuration","title":"Getting Started - Configuration","type":"extras","doc":"It is possible to configure ex_rerun using the following parameters: Note: the example below shows the default values. config :ex_rerun, scan_interval: 4000, silent: false, file_types: [&quot;.ex&quot;, &quot;.exs&quot;, &quot;.eex&quot;, &quot;.json&quot;], paths: [&quot;lib&quot;, &quot;priv&quot;], ignore_pattern: nil, tasks: [:elixir] where: scan_interval specifies the number of ms to wait between rerun checks, silent toggles whether to print the output of the tasks registered, every time ex_rerun runs, file_types lists which file types that will trigger a rerun when changed, paths lists which folders to monitor, ignore_pattern specifies a regular expression, e.g. ~r{\\.?#(.)}, matching files that should to be ignored even if they have a file type included in file_types, and tasks enumerates the mix tasks to run each time a code modification occurs, possible built-in values are: :elixir, :test, :escript, where :elixir recompiles Elixir source code (same as Mix.Tasks.Compile.Elixir), :test reruns any mix tests in the project (same as Mix.Tasks.Test), and escript rebuilds a escript file (same as Mix.Tasks.Escript.Build). Furthermore, tasks can also include custom mix tasks. For example, the hex package elm_compile defines the Mix.Tasks.Compile.Elm task which allows mix to also compile Elm files in a mix project. An example project config using ex_rerun and elm_compile might look like so: config :ex_rerun, file_types: [&quot;.elm&quot;, &quot;.ex&quot;, &quot;.exs&quot;, &quot;.eex&quot;, &quot;.json&quot;], paths: [&quot;lib&quot;, &quot;priv&quot;, &quot;web&quot;], ignore_pattern: ~r{\\.?#(.)}, tasks: [:elixir, Mix.Tasks.Compile.Elm] Another example of a custom mix task could be to generate API documentation for a project based on a set of RAML files."},{"ref":"changelog.html","title":"Changelog","type":"extras","doc":"Changelog"},{"ref":"changelog.html#v0-3-0-2020-02-02","title":"Changelog - v0.3.0 [2020-02-02]","type":"extras","doc":"Added Adds the property ignore_pattern to the ex_rerun configuration: config :ex_rerun, ... ignore_pattern: ~r{\\.?#(.)} which provides some finer granularity to ignore temporary or autogenerated files that happens to have a file type that is in the file_types list. For example, the pattern above, ~r{\\.?#(.)}, ignores Emacs auto-save and interlocking files as these files happen to have similar filenames as the files they are related to but prepended with a # or .#. The default value for ignore_pattern is nil, meaning no further filtering is performed. Bumps the version Elixir version used for compiling ex_rerun to 1.9."},{"ref":"changelog.html#v0-2-0-2019-03-24","title":"Changelog - v0.2.0 [2019-03-24]","type":"extras","doc":"Changed Changes the configuration format to the following: config :ex_rerun, scan_interval: 4000, silent: false, file_types: [&quot;.ex&quot;, &quot;.exs&quot;, &quot;.eex&quot;, &quot;.json&quot;], paths: [&quot;lib&quot;, &quot;priv&quot;], tasks: [:elixir] where: tasks enumerates the mix tasks to run each time a code modification occurs, possible built-in values are: :elixir, :test, :escript, where :elixir recompiles Elixir source code (same as Mix.Tasks.Compile.Elixir), :test reruns any mix tests in the project (same as Mix.Tasks.Test), and escript rebuilds a escript file (same as Mix.Tasks.Escript.Build). Furthermore, tasks can also include custom mix tasks. For example, the hex package elm_compile defines the Mix.Tasks.Compile.Elm task which allows mix to also compile Elm files in a mix project."},{"ref":"changelog.html#v0-1-0-2019-01-12","title":"Changelog - v0.1.0 [2019-01-12]","type":"extras","doc":"Added Support for monitoring Elixir and other source files and running mix tasks on code modification changes using the following configuration parameters: # Default values config :ex_rerun, scan_interval: 4000, silent: false, elm: false, test: false, escript: false, paths: [&quot;lib&quot;, &quot;priv&quot;], file_types: [&quot;.ex&quot;, &quot;.exs&quot;, &quot;.eex&quot;, &quot;.json&quot;] where: scan_interval specifies the number of ms to wait between rerun checks, silent toggles whether to print every time ex_rerun recompiles, elm toggles whether to run the elm compilation task on recompile, requires elm_compile to be installed as a project dependency, test toggles whether to also run mix test after each recompilation, escript toggles whether to run the escript compilation task on recompile, paths lists which folders to monitor, and file_types lists which files that will trigger a rerun when changed."}]